/*
 author:dushaobin
 email:shaobin.du@3g2win.com
 description:appcan常用插件
 created:2014,08.18
 update:chenxue:xue.chen3g2win.com

 */
/*global appcan,window */
appcan.use("detect", function($, detect) {
    /**注释这个问题的原因是物理像素高度是设备像素的n倍**/
    // if (detect.os.ios) {
    //     var viewport = document.getElementsByName("viewport");
    //     var scale = window.devicePixelRatio ? (1 / window.devicePixelRatio) : 1;
    //     $("[name='viewport']").attr("content", "width=device-width,target-densitydpi=device-dpi,initial-scale=" + scale + ", minimum-scale=" + scale + ", maximum-scale=" + scale);
    //     var fontsize = $("body").css("font-size");
    //     $("body").css("font-size", parseInt(fontsize) * window.devicePixelRatio + "px");
    // }
})

appcan.extend(function(app, exports, module) {
    var $ = appcan.require('dom');
    var appWin = appcan.require('window');
    var locStorage = appcan.require('locStorage');
    var view = appcan.require('view');
    /*
     * 兼容pc，移动设备的封装
     * @param String className 要更改的class
     * @param Functon fun 执行结束后的回调
     *
     */
    function isWindows() {
        if(window.navigator.platform == "Win32") return true;
        if (!('ontouchstart' in window))
            return true;
    }

    function button(selector, className, fun) {
        $(selector).on(isWindows() ? "mousedown" : "touchstart", function() {
            appcan.touch(className, fun);
        })
    }

    function updateSwitch(obj) {
        var value = obj.attr("data-checked") || 'false';
        value = (value == 'false' ? 'true' : 'false');
        obj.attr("data-checked", value);
        value == 'false' ? obj.addClass("switch-active") : obj.removeClass("switch-active");
        value == 'false' ? obj.removeClass("bc-head") : obj.addClass("bc-head");

        
    }

    function switchBtn(selector, css, cb) {
        if ( typeof css == 'function') {
            cb = css;
            css = null;
        }
        var obj = $(selector);
        for (var i = 0; i < obj.length; i++) {
            var value = $(obj[i]).attr("data-checked") || 'false';
            value == 'false' ? $(obj[i]).removeClass( css ? css : "bc-head") : $(obj[i]).addClass( css ? css : "bc-head");
        }
        $(selector).on("tap", function(evt) {
            var obj = $(evt.currentTarget);
            var value = obj.attr("data-checked") || 'false';
            value = (value == 'false' ? 'true' : 'false');
            obj.attr("data-checked", value);
            value == 'false' ? obj.removeClass( css ? css : "bc-head") : obj.addClass( css ? css : "bc-head");
            value = value == 'false'?false:true;
            cb(obj, value);
        })
    }

    function select(sel, cb) {
        $("select",$(sel))[0].selectedIndex = -1;
        var tl =$(sel).find("div[class=text]");
        var sl =$(sel).find('select');
        var op =sl.find('option');
        var index =parseInt(sl.attr('selectedIndex'));
        if(index != -1){
            tl.html(sl[0].options[index].text);
        }

        $("select", $(sel)).on("change", function(evt) {
            var ele = $(evt.currentTarget);
            appcan.selectChange(evt.currentTarget);
            cb && cb(ele, ele.val());
        });
    }


    function touch(className, fun) {
        var ele = window.event.currentTarget || window.event.srcElement;
        var eventType = window.event.type;
        var hasTouch = ('ontouchstart' in window);
        var $ele = $(ele);
        var ed = $ele.data('inline_event_data');
        if (ed) {
            return;
        }
        ed = {};
        ed.clickFun = $ele.attr('onclick');
        ed.startFun = $ele.attr('ontouchstart') || $ele.attr('onmousedown');
        ed.endFun = $ele.attr('ontouchend') || $ele.attr('onmouseup');
        ed.startClassName = className;
        ed.startCallFun = fun;
        ed.endClassName = ed.startClassName;
        ed.endCallFun = ed.startCallFun;
        $ele.data('inline_event_data', ed);
        $ele.attr('onclick', '');
        $ele.attr('ontouchstart', '');
        $ele.attr('onmousedown', '');
        $ele.attr('ontouchend', '');
        $ele.attr('onmouseup', '');
        if (hasTouch) {
            //set click and change css
            $ele.on('touchstart', function() {
                if (!ed.startClassName) {
                    return;
                }
                $(this).addClass(ed.startClassName);
            });
            $ele.on('touchend', function() {
                if (!ed.endClassName) {
                    return;
                }
                $(this).removeClass(ed.endClassName);
            });
            $ele.on('touchcancel', function() {
                if (!ed.endClassName) {
                    return;
                }
                $(this).removeClass(ed.endClassName);
            });
            
            $ele.on('tap', function() {
                if (appcan.isFunction(ed.startCallFun)) {
                    ed.startCallFun.apply(this, [].slice.call(arguments));
                }
                var f = new Function(ed.clickFun);
                f();
            });
        } else {
            //just change css
            $ele.on('mousedown', function() {
                if (!ed.startClassName) {
                    return;
                }
                var that = this;
                $(this).addClass(ed.startClassName);
                setTimeout(function(){
                    $(that).removeClass(ed.endClassName);
                },300);
            });
            $ele.on('mouseup', function() {
                if (!ed.endClassName) {
                    return;
                }
                $(this).removeClass(ed.endClassName);
            });
            $ele.on('click', function() {
                if (appcan.isFunction(ed.startCallFun)) {
                    ed.startCallFun.apply(this, [].slice.call(arguments));
                }
                var f = new Function(ed.clickFun);
                f();
            });
        }
        //bind webkitTransitionEnd event
        $ele.addClass(ed.startClassName);
        $ele.on('webkitTransitionEnd', function() {
        });
    }

    /*
     * 设置相关check元素选中
     * @param Event e 点击该元素的事件
     * @param Function callback 执行结束后事件回调 todo:同步执行函数没有必要用回调
     *
     */
    function elementFor(e, callback) {
        var forEle;
        e = e || window.event;
        if (e.currentTarget) {
            forEle = e.currentTarget.previousElementSibling;
        } else {
            forEle = e.previousElementSibling;
        }
        var $forEle = $(forEle);
        if ($forEle.prop('tagName') === 'INPUT') {
            if ($forEle.attr('type') === 'checkbox') {
                forEle.checked = !forEle.checked;
                $forEle.trigger("change");
            }
            if ($forEle.attr('type') === 'radio' && !forEle.checked) {
                forEle.checked = 'checked';
                $forEle.trigger("change");
            }
        }
        if (appcan.isFunction(callback)) {
            callback(e, forEle.checked);
        }
    }

    /*
     * 如果是win平太设置body 默认字体
     */
    function initFontsize() {
        var platform = window.navigator.platform;
        if (platform.toLowerCase().indexOf('win') > -1 || platform.toLowerCase().indexOf('wow') > -1 || platform.toLowerCase().indexOf('mac') > -1) {
            var fs = locStorage.getVal('defaultfontsize');
            if (fs) {
                $('body').css('font-size', fs);
            }
        }
    }

    /*
     * 下拉列表控件
     * @param ELE id 下拉列表select标签的对象
     */
    var selectChange = function(sel) {
        var sl = $(sel)[0];
        if (sl) {
            var sp = sl.parentElement;
            //<span>
            if (sp) {
                var ch = sp.getElementsByTagName('div')[0];
                var t = sl.options[sl.selectedIndex].text;
                if (ch) {
                    $(ch).html(t);
                }
            }
        }
    };
    /*
     * 字符组去除后面空格
     * @param Object e event对象
     * @param Boolean col 布尔值
     */
    var fold = function(e, col) {
        e = e || window.event;
        var a = e.currentTarget.nextElementSibling;
        if (a.nodeName == 'DIV') {
            var $a = $(a);
            if (col) {
                $a.removeClass('col-c');
            } else {
                $a.addClass('col-c');
            }
        }
    };
    /*
     * parseInt
     * @param String s 字符串
     */
    var toInt = function(s) {
        return parseInt(s);
    };
    /*
     * 停止事件的传播
     * @param Object t
     */
    var stopPropagation = function(t) {
        if (!t.cancelClick) {
            t.cancelClick = true;
            t.addEventListener('click', function() {
                event.stopPropagation();
            }, true);
        }
    };
    /*
     * 用指定元素的样式打开一个弹框
     * @param String eleId 指定元素的id
     * @param String url 要打开的连接地址
     * @param Int left 距左边的距离
     * @param Int top 距上边的距离
     * @param String name 窗口名称，默认为id
     * @param String  
     *
     */
    function openPopoverByEle(eleId, url, left, top, type, name) {
        if (!eleId) {
            return;
        }
        var ele = $('#' + eleId);
        appWin.openPopover({
            name : ( name ? name : eleId),
            url : url,
            left : left,
            top : top,
            width : ele.width(),
            height : ele.height(),
            type:(type || 0)
        });
    }

    /*
     * 简单的模版插件
     */
    var tmpl = function() {
        var config = {
            evaluate : /<%([\s\S]+?)%>/g,
            interpolate : /<%=([\s\S]+?)%>/g,
            escape : /\${([\s\S]+?)}/g
        };
        var args = [].slice.call(arguments);
        args.push(config);
        return view.render.apply(this, args);
    };
    var tmplAppend = function() {
        var config = {
            evaluate : /<%([\s\S]+?)%>/g,
            interpolate : /<%=([\s\S]+?)%>/g,
            escape : /\${([\s\S]+?)}/g
        };
        var args = [].slice.call(arguments);
        args.push(config);
        return view.appendRender.apply(this, args);
    };
    /*
     * 打开一个新窗口（main目录下使用）
     * @param String name 窗口的名字
     * @param String url 要加载的地址
     * @param Int aniId 动画效果
     * @param int tpye 窗口的类型
     * 0:普通窗口
     * 1:OAuth 窗口
     * 2:加密页面窗口
     * 4:强制刷新
     * 8:url用系统浏览器打开
     * 16:view不透明
     * 32:隐藏的winwdow
     * 64:等待popOver加载完毕后显示
     * 128:支持手势
     * 256:标记opn的window上一个window不隐藏
     * 512:标记呗open的浮动窗口用友打开wabapp
     * @param animDuration 动画时长
     *
     */
    function openWinWithUrl(name, url, aniId, type, animDuration) {
        clearVideoInterval();
        //判断商城首页的视频的状态，如果视频为开则关闭视频
        for(var i = 1 ; videoPlayer && i < videoPlayer.length; i++){
            if (videoPlayer[i]) {
                videoPlayer[i].pause();
                $('#playBtn'+i).removeClass('uhide');
            }
        }
        for(var i = 0 ; article && i < article.length; i++){
            if (article[i]) {
                article[i].pause();
                $('#playBtn'+i).removeClass('uhide');
            }
        }
        for(var i = 0 ; arrVideoArticle && i < arrVideoArticle.length; i++){
            if (arrVideoArticle[i]) {
                arrVideoArticle[i].pause();
                $('#videoPlayBtn'+i).removeClass('uhide');
            }
        }
        if (!name) {
            return;
        }
        
        switch(name){
            //打开根页面
            case "root":
                url = "../../" + url;
                break;
            //从main目录窗口打开根目录窗口
            case "backRoot":
                name = url.replace(".html","");
                url = "../../" + url;
                saveHTML(name);
                break;
            //同组目录内打开窗口
            case "group":
                name = url.replace(".html","");
                temp1 = url.substring(0,url.indexOf('-'));
                if(temp1){
                    name = temp1;
                    url = url.substring(url.indexOf('-')+1,url.length);
                }

                saveHTML(name);
                break;
            //默认以main目录打开窗口
            default:
                var tmp = url.replace(".html","");
                temp1 = url.substring(0,url.indexOf('-'));
                if(temp1){
                    url = url.substring(url.indexOf('-')+1,url.length);
                    url = "../" + name + "/" + url;
                    name = temp1;
                }else{
                    url = "../" + name + "/" + url;
                    name = tmp;
                }
                
                saveHTML(name);
                break;
        }
        appcan.window.open({
            name : name,
            data : url,
            aniId : (aniId || 10),
            type : (type || 0),
            animDuration : (animDuration || 300)
        });
    }
    /**
     * 打开一个新窗口（根——root目录下使用）
     */
    function openNowRootUrl(name, url, aniId, type, animDuration) {
        clearVideoInterval();
        //判断商城首页的视频的状态，如果视频为开则关闭视频
        for(var i = 1 ; videoPlayer && i < videoPlayer.length; i++){
            if (videoPlayer[i]) {
                videoPlayer[i].pause();
                $('#playBtn'+i).removeClass('uhide');
            }
        }
        for(var i = 0 ; article && i < article.length; i++){
            if (article[i]) {
                article[i].pause();
                $('#playBtn'+i).removeClass('uhide');
            }
        }
        for(var i = 0 ; arrVideoArticle && i < arrVideoArticle.length; i++){
            if (arrVideoArticle[i]) {
                arrVideoArticle[i].pause();
                $('#videoPlayBtn'+i).removeClass('uhide');
            }
        }
        if (!name) {
            return;
        }
        if(name != "root"){
            saveHTML(name);
        }
        //从跟目录窗口打开main目录窗口
        if(name == "goMain"){
            temp1 = url.substring(0,url.indexOf('-'));
            temp2 = url.substring(url.indexOf('-')+1,url.length);
            name = temp2.replace(".html","");
            url = "main/" + temp1 + "/" + temp2;
        }
        appcan.window.open({
            name : name,
            data : url,
            aniId : (aniId || 10),
            type : (type || 0),
            animDuration : (animDuration || 300)
        });
    }

    /*
     * 关闭窗口
     */
    function closeWin(aniId) {
        aniId = aniId || -1;
        appWin.close(aniId);
    }

    /*
     * 设置localstorage的值
     */
    function setLocalVal(key, val) {
        return locStorage.setVal(key, val);
    }

    /*
     * 获取localstorage的值
     */
    function getLocalVal(key) {
        return locStorage.getVal(key);
    }

    /*
     * 在窗口中执行脚本
     */
    function execScriptInWin(name, scriptContent) {
        if (!name || !scriptContent) {
            return;
        }
        appWin.evaluateScript({
            name : name,
            scriptContent : scriptContent
        });
    }

    /*
     * 初始弹动，无回调方法
     */
    function initBounce() {
        appWin.setBounceType('0', 'rgba(255,255,255,0)', 0);
        appWin.setBounceType('1', 'rgba(255,255,255,0)', 0);
    }

    /*
     * 获取当前对象内属性的个数
     */
    function objLength(obj) {
        var c = 0;
        if (!obj) {
            return c;
        }
        if (appcan.isArray(obj)) {
            return obj.length;
        } else {
            if (!appcan.isPlainObject(obj)) {
                return c;
            }
            for (var i in obj) {
                c++;
            }
            return c;
        }
    }

    /*
     * 获取模版中的开始结束回调
     * @param String k1 last: 或者 first:
     */
    function getTempCallback(d, c, k1, k2, l) {
        var q = c.match(/(first:|last:)(\"|\'*)([^\"\']*)(\"|\'*)/);
        if (!q) {
            return;
        }
        if (q[1] == k1) {
            if (q[2] == '\"' || q[2] == '\'') {
                return q[3];
            } else {
                return d[q[3]];
            }
        } else if (q[1] == k2 && l > 1) {
            return "";
        }
    }

    /*
     *
     *
     *
     */
    function oldTemp(t, d, i, l, cb) {
        //匹配出 $｛内容｝
        return t.replace(/\$\{([^\}]*)\}/g, function(m, c) {
            if (c.match(/index:/)) {
                return i;
            }
            if (c.match(/cb:/) && cb) {
                return cb(d, c.match(/cb:(.*)/));
            }
            if (i == 0) {
                var s = getTempCallback(d, c, "first:", "last:", l);
                if (s) {
                    return s;
                }
            }
            if (i == (l - 1)) {
                var s = getTempCallback(d, c, "last:", "first:", l);
                if (s) {
                    return s;
                }
            }
            var ar = c.split('.');
            var res = d;
            for (var key in ar) {
                res = res[ar[key]];
                if(ar[key] == 'final_amount'){
                    if(res == 0){
                        res = '0';
                    }
                }
            }
            return res || "";
        });
    };

    /*
     *
     * 根据指定的列表返回对应的数据
     *
     */
    var oldTempRenderList = function(t, dd, l, cb, scb) {
        var r = "";
        var index = 0;
        for (var i in dd) {
            if (scb) {
                scb(0, i, dd[i]);
            }
            var rr = oldTemp(t, dd[i], index, l, cb);
            if(rr.indexOf('class="btn-r"') == '-1'){
                rr = rr.replace('<div class="lineto" style="width:100%;text-align:right;">','<div style="width:100%;text-align:right;">');
                rr = rr.replace('style="text-align:right;padding: 0.8em 0;font-size: 0.75em;color: #757575;"','');
            }
            if (scb) {
                scb(1, rr, dd[i]);
            }
            r += rr;
            index++;
        }
        return r;
    };
    /*
     *
     * 返回指定的数据
     *
     */
    function oldTempRender(t, dd, cb) {
        return oldTemp(t, dd, -1, -1, cb);
    }
    
    /*
     *按顺序执行
     */
    function series(tasks,callback){
        if(appcan.isFunction(tasks)){
            callback = tasks;
            tasks = [];
        }
        callback = appcan.isFunction(callback) ? callback : function(){};
        var errData = 0;
        var resData = null;
        var taskIdx = 0;
        
        function nextTask(){
            if(taskIdx >= tasks.length){
                callback(0);
                return;
            }
            var tsk = tasks[taskIdx];
            if(tsk && appcan.isFunction(tsk)){
                try{
                    if(tsk(function(err,data){
                        if(err === 0){
                            taskIdx++;
                            nextTask();
                        }else{
                            //结束任务
                            callback(err,data);
                            return;
                        }
                    }) === false){
                        //结束任务
                        callback(0);
                        return;
                    }
                }catch(e){
                    callback(e);
                }
            }
        }
        
        nextTask();
        
    }
    
    /**
     * 打开预指定新窗口
     * @param {String} a 跳转类型
     * @param {Object} b 打开新窗口传递参数
     * @param {Int} c 打开新窗口动画ID
     * @author zhangh 2016-4-26
     */
    function pageJump(a, b, c) {
        //跳转类型JSON数组
        var _dump_data = {
            none : {
                page : false,
            },
            store : {
                page : 'pointList',
                key : 'point_goods_list',
            },
            definedpage : {
                page : 'definedpage',
                key : 'definedpage_id',
            },
        }

        var dump_data = _dump_data[a];
        var page;
        page = dump_data.page;
        if (!page)
            return;
        if (page == 'definedpage'){
            var end = b['pagename'].indexOf('.');
            page = b['pagename'].substring(0,end) ;
        }
        if (!b)
            return;
        if(a =='store'){
            appcan.locStorage.setVal('store_id',b['pagename']);
            appcan.window.open({
                name : 'shop',
                data : "shop.html",
                aniId : c || 2,
                type : 0,
                animDuration : 300
            });
         return;
        }
        var extraInfo = {};
        for(var i in dump_data){
            if(i=='key'){
                extraInfo[dump_data[i]] = b.data;
            }else if(i=='page'){
                continue;
            }else{
                extraInfo[i] = dump_data[i];
            }
        }
        if (extraInfo) {
            appcan.locStorage.setVal("extraInfo"+dump_data['key'], extraInfo);
        } else {
            appcan.locStorage.remove("extraInfo"+dump_data['key']);
        }
        
        sendParams = extraInfo;
        var name = page+dump_data['key']+b.data;
        page && appcan.window.open({
            name : name,
            data : page + ".html",
            aniId : c || 2,
            type : 0,
            animDuration : 300
        });
        
    }

    function windowName() {
        var name = window.frameElement && window.frameElement.id || '';
        if (name) {
            /*去除头尾*/
            name = name.replace('_main', '').replace('_pop_content', '');
            name = name.split('_');
            name = name.splice(1, name.length - 1);
            name = name.join('_');
        }
        return name;
    }

    //for emulator
    $(document).ready(function() {

    });
    initFontsize();

    module.exports = {
        elementFor : elementFor,
        touch : touch,
        initFontsize : initFontsize,
        openPopoverByEle : openPopoverByEle,
        resizePopoverByEle : appWin.resizePopoverByEle,
        tmpl : tmpl,
        tmplAppend : tmplAppend,
        openWinWithUrl : openWinWithUrl,
        openNowRootUrl : openNowRootUrl,
        closeWin : closeWin,
        closePopover : appWin.closePopover,
        setLocVal : setLocalVal,
        getLocVal : getLocalVal,
        execScriptInWin : execScriptInWin,
        bringPopoverToFront : appWin.bringPopoverToFront,
        initBounce : initBounce,
        evaluatePopoverScript : appWin.evaluatePopoverScript,
        alert : appWin.alert,
        getObjLength : objLength,
        getTempCallback : getTempCallback,
        temp : oldTemp,
        tempRenderList : oldTempRenderList,
        tempRender : oldTempRender,
        stopPropagation : stopPropagation,
        toInt : toInt,
        selectChange : selectChange,
        fold : fold,
        button : button,
        select : select,
        "switch": switchBtn,
        switchBtn : switchBtn,
        series:series,
        updateSwitch:updateSwitch,
        pageJump : pageJump,
        windowName: windowName
    };
});

appcan.ready(function(){
    var ios7style=uexWidgetOne.iOS7Style;
    var isFullScreen = uexWidgetOne.isFullScreen;
    if (ios7style == '1' && isFullScreen != '1') {
      $("body").addClass("uh_ios7");
    }
    var pageNames = thisPageName();
    if (pageNames[0].indexOf("_content") == -1 && pageNames[0].indexOf("index_") == -1) {
        saveHTML(pageNames[0]);
    }
});


//获取当前页面名称
function thisPageName(){
    var a = location.href;
    var b = a.split("/");
    var c = b.slice(b.length-1, b.length).toString(String).split(".");
    return c.slice(0, 1);
}
//记录已经打开的页面
function saveHTML(name) {
    var locStorage = appcan.require('locStorage');
    var htmlDataStr = locStorage.getVal('html_records');
    var htmlData;
    var value = "true";
    if (htmlDataStr == null) {
        htmlData = new Array();
    } else {
        htmlData = eval(htmlDataStr);
        for (var i = 0; i < htmlData.length; i++) {
            if (htmlData[i].records == name) {
                value = "false";
                break;
            }
        }
    }
    if (value == "true") {
        var list = {
            records : name
        }
        htmlData.push(list);
        locStorage.setVal('html_records', htmlData);
    }
};
//关闭打开的所有页面
function closeHTML(){
    var locStorage = appcan.require('locStorage');
    var htmlDataStr = locStorage.getVal('html_records');
    var htmlData;
    var value="true"; //强制刷新进入首页2016年4月1日17:57:13 caixf
    if(htmlDataStr != null){
        htmlData = eval(htmlDataStr);
        for (var i = 0; i < htmlData.length; i++) {
            if(htmlData[i].records == "root"){
                value = "true";
            }else{
                appcan.window.evaluateScript({
                    name : htmlData[i].records, //窗口名称  
                    scriptContent : 'appcan.window.close();'
                }); 
            }
        }
    }
    if(value == "true"){
        appcan.window.evaluateScript({
            name : 'root',
            scriptContent : 'openFrames("index_home","","1")'
        });
    }
};
//清空算法
function clearHTMl(){
    var locStorage = appcan.require('locStorage');
    var htmlDataStr = locStorage.getVal('html_records');
    if(htmlDataStr !=null){
       locStorage.remove('html_records');
    }
}
//刷新相应页面
function refreshPage(){
     // appcan.window.evaluateScript({
        // name:'activity',
        // scriptContent:'window.location.reload()'
    // });
    appcan.window.evaluateScript({
        name:'act_detail',
        scriptContent:'getData()'
    });
    appcan.window.evaluateScript({
        name:'activity_list',
        scriptContent:'getData()'
    });
    appcan.window.evaluateScript({
        name:'activityVoucher',
        scriptContent:'getData()'
    });
    // appcan.window.evaluateScript({
        // name:'root',
        // scriptContent:'window.location.reload()'
    // });
}
