/**
 * 1.初始化地址选项
 * 初始化省份: initPro()
 * 初始化城市: initCity(pro_id)
 * 初始化地区: initSelectArea(city_id)
 * 初始化地区2: initSelectArea2(area1_id)
 * 
 * 2.初始化选择默认地址选项
 * 内容初始化并选择初始值： set_region_data(data,id)
 * 
 * 3.组合select
 * 组合select html代码: select_html(options, id)
 */

// 初始化省份
function initPro() {
    var data = {};
    data['ctlname'] = 'user_newaddress';
    data['method'] = 'getAllArea';
    AJAX.post(data, function(json) {
        if (json.status) {
            select_html(json.aArea, selectPro);
            selectPro.selectedIndex = 0;
            selectProTxt.innerText = '请选择';
            $('#hideArea')[0].style.display = 'none';
        } else {
            openAlert("", json.msg);
        }
        document.getElementById('selectCity').disabled=true;
        document.getElementById('selectArea').disabled=true;
    }, function() {
        openTosat('网络超时');
    }, 0);
}

// 初始化城市
function initCity(pro_id) {
    var data = {};
    data['ctlname'] = 'user_newaddress';
    data['method'] = 'getAllArea';
    data['parentId'] = pro_id;
    AJAX.post(data, function(json) {
        if (json.status) {
            select_html(json.aArea, selectCity);
            selectCity.selectedIndex = 0;
            selectCityTxt.innerText = '请选择';

            selectArea.innerHTML = '<option value=0>请选择</option>';
            selectAreaTxt.innerText = '请选择';
            $('#hideArea')[0].style.display = 'none';
        } else {
            openAlert("", json.msg);
        }
    }, function() {
        openTosat('网络超时');
    }, 0);
}

// 初始化地区
function initSelectArea(city_id) {
    var data = {};
    data['ctlname'] = 'user_newaddress';
    data['method'] = 'getAllArea';
    data['parentId'] = city_id;
    AJAX.post(data, function(json) {
        if (json.status) {
            select_html(json.aArea, selectArea);
            selectArea.selectedIndex = 0;
            selectAreaTxt.innerText = '请选择';
            $('#hideArea')[0].style.display = 'none';
        } else {
            openAlert("", json.msg);
        }
    }, function() {
        openTosat('网络超时');
    }, 0);
}

// 初始化地区2
function initSelectArea2(area1_id) {
    var data = {};
    data['ctlname'] = 'user_newaddress';
    data['method'] = 'getAllArea';
    data['parentId'] = area1_id;
    data['selectArea2'] = true;
    AJAX.post(data,function(json) {
        if (json.status) {
            var aAreaArr = json.aArea;
            if (aAreaArr.length > 0) {
                select_html(aAreaArr, selectArea2);
                selectArea2.selectedIndex = 0;
                selectArea2.disabled = false;
                selectArea2Txt.innerText = selectArea2.selectedOptions[0].innerText;
                $('#hideArea')[0].style.display = 'block';
                $('#hideArea')[0].style.display = '-webkit-box';
            } else {
                selectArea2.innerHTML = '';
                selectArea2.disabled = true;
                $('#hideArea')[0].style.display = 'none';
            }
        } else {
            openAlert("", json.msg);
        }
    }, function() {
        openTosat('网络超时');
    }, 0);
}

// 内容初始化并选择初始值：
function set_region_data(data,id) {
    select_html(data.data,id);
    id.value = data.select;
    id.parentElement.children[0].innerHTML = data.name;
}

// 组合select html代码
function select_html(options, id) {
    var str = '<option value>请选择</option>';
    var option, region_id, region_name;
    for (var i = 0, len = options.length; i < len; i++) {
        option = options[i];
        region_id = option.region_id;
        region_name = option.local_name;
        str = str + "<option value='" + region_id + "'>" + region_name + "</option>";
    }
    id.innerHTML = str;
}

appcan.select(".select", function(ele, value) {
    if(document.getElementById("selectPro").value){
        document.getElementById('selectCity').disabled=false;
        document.getElementById('selectArea').disabled=false;
        switch (ele[0].id) {
            case "selectPro":
                initCity(value);
                break;
            case "selectCity":
                if(document.getElementById("selectCity").value){
                    initSelectArea(value);
                }else{
                    document.getElementById('selectArea').disabled=true;
                    document.getElementById('selectAreaTxt').innerText = '请选择';
                }
                break;
            case "selectArea":
                if(selectArea2){
                    initSelectArea2(value);
                }
                break;
        }
    }else{
        document.getElementById('selectCity').disabled=true;
        document.getElementById('selectArea').disabled=true;
        document.getElementById('selectCityTxt').innerText = '请选择';
        document.getElementById('selectAreaTxt').innerText = '请选择';
    }
});
