var css = document.createElement('link');
css.href = "../../css/weui.min.css";
css.rel = "stylesheet";
css.type = "text/css";
document.getElementsByTagName('head')[0].appendChild(css);
/**
 * 警告弹框
 * @param {String} tit 标题
 * @param {String} body 内容
 * @param {String} btn 按钮文字
 * @param {Function} fn 确认回调方法
 */
function openAlert(tit, body, btn, fn) {
  btn = btn ? btn : '确定';
  var html =
    '<div id="custom_dialog_alert" class="weui_dialog_alert">\
    <div class="weui_mask"></div>\
    <div class="weui_dialog">\
      <div class="weui_dialog_hd">\
        <strong class="weui_dialog_title">' + tit + '</strong>\
      </div>\
      <div class="weui_dialog_bd">' + body + '</div>\
      <div class="weui_dialog_ft">\
        <a id="close_custom_dialog_alert" href="javascript:;" class="weui_btn_dialog primary">' + btn + '</a>\
      </div>\
    </div>\
  </div>';
  $('body').append(html);
  appcan.button("#close_custom_dialog_alert", "", function(){
      closeAlert();
      if ($.isFunction(fn)) {
        fn();
      }
  })
}

function closeAlert(fn) {
  $("#custom_dialog_alert").remove();
}
/**
 * 确认弹框
 * @param {String} tit 标题
 * @param {String} body 内容
 * @param {String} comfirmbtn 确认按钮文字
 * @param {String} cancelbtn 取消按钮文字
 * @param {Function} comfirmfn 确认回调方法
 * @param {Function} cancelfn 取消回调方法
 */
function openConfirm(tit, body, comfirmbtn, cancelbtn, comfirmfn, cancelfn) {
  comfirmfn = comfirmfn ? comfirmfn : "";
  cancelfn = cancelfn ? cancelfn : "";
  cancelbtn = cancelbtn ? cancelbtn : '取消';
  comfirmbtn = comfirmbtn ? comfirmbtn : '确认';
  var html =
    '<div id="custom_dialog_confirm" class="weui_dialog_confirm">\
    <div class="weui_mask"></div>\
    <div class="weui_dialog1">\
      <div class="weui_dialog_hd">\
        <strong class="weui_dialog_title1">' + tit + '</strong>\
      </div>\
      <div class="weui_dialog_bd">' + body + '</div>\
      <div class="weui_dialog_ft">\
        <a id="cancel_custom_dialog_confirm" href="javascript:;" class="weui_btn_dialog default">' + cancelbtn + '</a>\
        <a id="comfirm_custom_dialog_confirm" href="javascript:;" class="weui_btn_dialog primary">' + comfirmbtn + '</a>\
      </div>\
    </div>\
  </div>';
  $('body').append(html);
  appcan.button("#cancel_custom_dialog_confirm", "", function(){
      closeConfirm();
      if ($.isFunction(cancelfn)) {
        cancelfn();
      }
  });
  appcan.button("#comfirm_custom_dialog_confirm", "", function(){
      //摇一摇输入手机号
      if(appcan.locStorage.getVal('page_name') == 'shake_gen_coupons' || appcan.locStorage.getVal('page_name') == 'shake_card' || appcan.locStorage.getVal('page_name') == 'prize_card'){
          phone = $('#phoneNm').val();
      }
      event.stopPropagation();
      closeConfirm();
      if ($.isFunction(comfirmfn)) {
        comfirmfn();
      }
  });
}

function closeConfirm(fn) {
  $("#custom_dialog_confirm").remove();
}
/**
 * 显示信息toast
 * @param {String} body 显示内容
 * @param {Int} time 关闭时间,单位为毫秒,默认1.5秒
 * @param {Function} fn Toast关闭后的回调方法
 */
/**
 * 重写弹出框 lirm update 2017-7-17
 */
function openToast(body, time, fn) {
  time = time ? time : 2000;
  appcan.window.openToast(body, time, 5);
}
/**
 * 显示loading动画
 * @param {String} body 提示信息
 * @param {Int} time 超时时间,单位为毫秒
 */
function openLoadingToast(body, time) {
  body = body ? body : '加载中...';
  var html = 
  '<div id="custom_loadingToast" class="weui_loading_toast">\
    <div class="weui_mask_transparent"></div>\
    <div class="weui_toast">\
      <div class="weui_loading">\
        <div class="weui_loading_leaf weui_loading_leaf_0"></div>\
        <div class="weui_loading_leaf weui_loading_leaf_1"></div>\
        <div class="weui_loading_leaf weui_loading_leaf_2"></div>\
        <div class="weui_loading_leaf weui_loading_leaf_3"></div>\
        <div class="weui_loading_leaf weui_loading_leaf_4"></div>\
        <div class="weui_loading_leaf weui_loading_leaf_5"></div>\
        <div class="weui_loading_leaf weui_loading_leaf_6"></div>\
        <div class="weui_loading_leaf weui_loading_leaf_7"></div>\
        <div class="weui_loading_leaf weui_loading_leaf_8"></div>\
        <div class="weui_loading_leaf weui_loading_leaf_9"></div>\
        <div class="weui_loading_leaf weui_loading_leaf_10"></div>\
        <div class="weui_loading_leaf weui_loading_leaf_11"></div>\
      </div>\
      <div class="weui_toast_content">'+ body +'</div>\
    </div>\
  </div>';
  $('body').append(html);
  if (time) {
    setTimeout(function(){
      $("#custom_loadingToast").remove();
    },time);
  }
}
/**
 * 关闭loading动画
 */
function closeLoadingToast(){
  $("#custom_loadingToast").remove();
}


function AllTrim(str){return str.replace(/\s*/g,'')}

/**
 * @method 下载方法
 * @author yuanjy 
 */
function download_share(data){
    var extraInfo = {};
    extraInfo['data'] = data;
    appcan.openWinWithUrl("downloadimg",extraInfo);
}
