/**
 * Created by Administrator on 2015/8/20 0020.
 */
//通用样式或预处理方法
//$('.preload-figure').attr('src', 'holder.js/80x100?text=loading');
/**
 * 生成图片游览图
 * 生成图片的大小会优先考虑css.preload-figure设置的样式
 * 其次是<img data-size="200x200">属性
 * 当都没有设定的时候,会默认铺满整个屏幕
 */
function preloadFigure() {
    $('.preload-figure').map(function() {
        //css属性,优先级2
        var width = $(this).css('width').replace('px', '');
        var height = $(this).css('height').replace('px', '');
        //data-size属性,优先级1
        var size = $(this).attr('data-size');
        if(size) {
            size = size.split('x');
            width = size[0];
            height = size[0];
        }
        //其余默认的大小
        if(width == 0) {
            width = document.body.clientWidth;
        }
        if(height == 0) {
            height = document.body.clientHeight;
        }
        $(this).attr('src', 'holder.js/'+ width+"x"+height+"?text=loading");
    });
}

/**
 * 生成省略图后,自动将图片替换成真实的图片
 * 基本思路:
 *  标签声明 <img data="http://www.baidu.com"></img>; data的值为图片url
 *  创建隐藏的img(非上述img),用以加载图片,当图片加载完毕,触发onload事件
 *  onload事件会自动寻找img,用以替换图片
 */
function loadFigure() {
    var images = $('.preload-figure');
    images.map(function () {
        var _images = $(this);
        var realImageUrl = _images.attr('data');
        var pic = new Image();
        pic.src = realImageUrl;
        pic.onload = function() {
            pic.onload = null;
            _images.attr('src', realImageUrl);
        };
        pic.onerror = function() {
            console.log("error to load image : " + realImageUrl);
        }
    });
}

//console.log简写
function l(text) {
    console.log(text);
}